<?php
namespace Teknisa\COZ\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class Pla10510Controller extends \Zeedhi\Framework\Controller\Report {

    protected $pla105010Service;
    protected $entityManager;
    protected $birtStrategy;
    protected $nrorg;
    protected $nrlista;
    protected $cd_report_name;
    
    public function __construct(ReportService $reportService, $entityManager, $birtStrategy, $pla105010Service) {
        $this->pla105010Service = $pla105010Service;    
        $this->entityManager = $entityManager;
        $this->birtStrategy = $birtStrategy;
        
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
    'rpp10510' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRLISTA'    => 'P_NRLISTA',
                'CDCENTRAL'  => 'P_CDCENTRAL',
                'DTINICIAL'   => 'P_DTPRODINI',
                'DTFINAL' => 'P_DTPRODFIN',
                'CDTIPOPRAT' => 'P_CDTIPOPRAT',
                'NRPLANPROD' => 'P_NRPLANPROD',
                'ORDENA' => 'P_ORDENA',
                'NRORG' => 'P_NRORG',
                'CDPICTPROD' => 'P_CDPICTPROD'
            )
        ),
    'rpp10511' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRLISTA'    => 'P_NRLISTA',
                'CDCENTRAL'  => 'P_CDCENTRAL',
                'DTINICIAL'   => 'P_DTPRODINI',
                'DTFINAL' => 'P_DTPRODFIN',
                'CDTIPOPRAT' => 'P_CDTIPOPRAT',
                'NRPLANPROD' => 'P_NRPLANPROD',
                'ORDENA' => 'P_ORDENA',
                'NRORG' => 'P_NRORG',
                'CDPICTPROD' => 'P_CDPICTPROD'
            )
        ),
    'rpp10512' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'NRLISTA'    => 'P_NRLISTA',
                'CDCENTRAL'  => 'P_CDCENTRAL',
                'DTINICIAL'   => 'P_DTPRODINI',
                'DTFINAL' => 'P_DTPRODFIN',
                'CDTIPOPRAT' => 'P_CDTIPOPRAT',
                'NRPLANPROD' => 'P_NRPLANPROD',
                'ORDENA' => 'P_ORDENA',
                'NRORG' => 'P_NRORG',
                'CDPICTPROD' => 'P_CDPICTPROD'
            )
        ),
    'rpp10513' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'NRPLANPROD' => 'P_NRPLANPROD',
                'ORIGEM' => 'P_ORIGEM',
                'ORDENA' => 'P_ORDENA',
                'NRORG' => 'P_NRORG',
                'CDPICTPROD' => 'P_CDPICTPROD'
            )
        ),
    'rpp11400' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRLISTA'    => 'P_NRLISTA',
                'CDCENTRAL'  => 'P_CDCENTRAL',
                'DTINICIAL'   => 'P_DTINI',
                'DTFINAL' => 'P_DTFIN',
                'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
                'CDTIPOPRAT' => 'P_CDTIPOPRAT',
                'NRPLANPROD' => 'P_NRPLANPROD',
                'ORDENA' => 'P_ORDENA',
                'SUPSERVICOS' => 'P_SUP_SERVICOS',
                'NRORG' => 'P_NRORG'
            )
        ),
    'rpp11401' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'NRLISTA'    => 'P_NRLISTA',
                'CDCENTRAL'  => 'P_CDCENTRAL',
                'DTINICIAL'   => 'P_DTINI',
                'DTFINAL' => 'P_DTFIN',
                'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
                'CDTIPOPRAT' => 'P_CDTIPOPRAT',
                'NRPLANPROD' => 'P_NRPLANPROD',
                'ORDENA' => 'P_ORDENA',
                'SUPSERVICOS' => 'P_SUP_SERVICOS',
                'NRORG' => 'P_NRORG'
            )
        ),
    'rpp11402' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'NRLISTA'    => 'P_NRLISTA',
                'CDCENTRAL'  => 'P_CDCENTRAL',
                'DTINICIAL'   => 'P_DTINI',
                'DTFINAL' => 'P_DTFIN',
                'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
                'CDTIPOPRAT' => 'P_CDTIPOPRAT',
                'NRPLANPROD' => 'P_NRPLANPROD',
                'ORDENA' => 'P_ORDENA',
                'SUPSERVICOS' => 'P_SUP_SERVICOS',
                'NRORG' => 'P_NRORG'
            )
        ),
    'rpp11403' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'NRLISTA'    => 'P_NRLISTA',
                'CDCENTRAL'  => 'P_CDCENTRAL',
                'DTINICIAL'   => 'P_DTINI',
                'DTFINAL' => 'P_DTFIN',
                'IDQUEBRAPAGINA' => 'P_IDQUEBRAPAGINA',
                'CDTIPOPRAT' => 'P_CDTIPOPRAT',
                'NRPLANPROD' => 'P_NRPLANPROD',
                'ORDENA' => 'P_ORDENA',
                'SUPSERVICOS' => 'P_SUP_SERVICOS',
                'NRORG' => 'P_NRORG'
            )
        ),
        'rpp15505' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDCENTRAL'  => 'P_CDCENTRAL',
                        'NRLISTA'    => 'P_NRLISTA',
                        'NRPLANPROD' => 'P_NRPLANPROD',
                        'DTINICIAL'   => 'P_DTPRODINI',
                        'DTFINAL' => 'P_DTPRODFIN',
                        'CDTIPOPRAT' => 'P_CDTIPOPRAT',
                        'NRORG' => 'P_NRORG'
                    )
            ),
        'rpp15506' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'NRLISTA'    => 'P_NRLISTA',
                        'CDCENTRAL'  => 'P_CDCENTRAL',
                        'DTINICIAL'   => 'P_DTPRODINI',
                        'DTFINAL' => 'P_DTPRODFIN',
                        'CDTIPOPRAT' => 'P_CDTIPOPRAT',
                        'NRPLANPROD' => 'P_NRPLANPROD',
                        'NRORG'     => 'P_NRORG'
                    )
            ),
        'rpp15508' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'NRLISTA'    => 'P_NRLISTA',
                        'CDCENTRAL'  => 'P_CDCENTRAL',
                        'DTINICIAL'   => 'P_DTPRODINI',
                        'DTFINAL' => 'P_DTPRODFIN',
                        'CDTIPOPRAT' => 'P_CDTIPOPRAT',
                        'NRPLANPROD' => 'P_NRPLANPROD',
                        'NRORG' => 'P_NRORG',
                        'CDPICTPROD' => 'P_CDPICTPROD'
                    )
            ),
        'rpp10514' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'NRLISTA'    => 'P_NRLISTA',
                        'CDCENTRAL'  => 'P_CDCENTRAL',
                        'DTINICIAL'   => 'P_DTPRODINI',
                        'DTFINAL' => 'P_DTPRODFIN',
                        'NRPLANPROD' => 'P_NRPLANPROD',
                        'ORDENA' => 'P_ORDENA', 
                        'NRORG' => 'P_NRORG',
                        'CDPICTPRAT' => 'P_CDPICTPRAT'
                    )
            ),
        'rpp10515' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'NRLISTA'    => 'P_NRLISTA',
                        'CDCENTRAL'  => 'P_CDCENTRAL',
                        'DTINICIAL'   => 'P_DTPRODINI',
                        'DTFINAL' => 'P_DTPRODFIN',
                        'NRPLANPROD' => 'P_NRPLANPROD',
                        'ORDENA' => 'P_ORDENA', 
                        'NRORG' => 'P_NRORG',
                        'CDPICTPRAT' => 'P_CDPICTPRAT'
                    )
            )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        //$row['ORIGEM'] = "PLANEJAMENTO";
        $this->cd_report_name = $row['CD_REPORT_NAME'];
        if ($this->cd_report_name <> 'rpp10513') {
            $this->pla105010Service->preencheCampos($row);
            $this->nrorg = $row['NRORG'];
            $this->nrlista = $row['LISTASERVFILI'];
            if ($this->nrlista != 'T') {
                
                $this->nrlista = $this->pla105010Service->geraListaServico(
                    $row
                );
                
            }

            $row['CDPRODINI'] = '0';
            $row['CDPRODFIN'] = 'Z';
            $row['NRLISTA'] = $this->nrlista;
            $row['CDTIPOPRAT'] = count($row['NMTIPOPRAT']) == 0 ? 'T'
                : $this->pla105010Service->concatArray($row['NMTIPOPRAT']);
        }
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
    }

    public function afterProcessReport(DTO\Request\Row $request, DTO\Response $response, $report) {
        // if($this->nrlista != 'T') {
        //     if ($this->cd_report_name == 'rpp11400' || $this->cd_report_name == 'rpp11401' || $this->cd_report_name == 'rpp11402'
        //         || $this->cd_report_name == 'rpp11403'){
        //         $this->pla105010Service->deletaListaServico($this->nrorg, $this->nrlista);
        //     }else{
        //         $this->pla105010Service->deletaLista($this->nrorg, $this->nrlista);
        //     }
        // }
    }
}